//
//  ReportViewController.m
//  PLS Mobile
//
//  Created by Daniel Workman on 06/05/2013.
//  Copyright (c) 2013 Daniel Workman. All rights reserved.
//

#import "ReportViewController.h"
#import "ASIHTTPRequest.h"
#import "ASIFormDataRequest.h"
#import "SBJson.h"
#import "MBProgressHUD.h"

@interface ReportViewController ()

@end

@implementation ReportViewController

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view delegate

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    if (section == 0)
    {
        if (self.status == JOB_STATUS_COMPLETED) {
            return @"Completion Report";
        } else {
            return @"Reason for Aborting";
        }
    }
    
    return @"";
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.section == 1) {
        // Confirm button pressed
        NSString *urlString = [[NSUserDefaults standardUserDefaults] stringForKey:@"database_url"];
        ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:urlString]];;
        [request setPostValue:@"update_job" forKey:@"request"];
        [request setPostValue:[NSString stringWithFormat:@"%d", self.sender.jobId] forKey:@"job_id"];
        [request setPostValue:self.reportText.text forKey:@"closing_report"];
        [request setPostValue:[NSString stringWithFormat:@"%d", self.status] forKey:@"status"];
        [request setDelegate:self];
        [request startAsynchronous];
        
        MBProgressHUD *hud = [MBProgressHUD showHUDAddedTo:self.view animated:YES];
        hud.labelText = @"Closing job...";
    }
}

- (void)requestFinished:(ASIHTTPRequest *)request
{
    [MBProgressHUD hideHUDForView:self.view animated:YES];
    
    if (request.responseStatusCode == 200) {
        // Job has been closed so navigate back to the home screen
        NSArray *allViewControllers = self.navigationController.viewControllers;
        NSInteger n = [allViewControllers count];
        [self.navigationController popToViewController: [allViewControllers objectAtIndex: (n-3)] animated: YES];
    } else {
        ALERT(@"Request Failed", request.responseStatusMessage);
    }
}

- (void)requestFailed:(ASIHTTPRequest *)request
{
    [MBProgressHUD hideHUDForView:self.view animated:YES];
    ALERT(@"Request Failed", [[request error] localizedDescription]);
}

@end
